//+------------------------------------------------------------------+
//|                                                Round Numbers.mq4 |
//|                                                    Space Finance |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Space Finance"
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window

extern int number_of_lines_below_above = 10;
extern int level_of_interest = 100;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   double round_levels,final_price_level;

   double market_price = (Bid + Ask) / 2;
   int x = (int) (market_price / Point);
   int y = x%level_of_interest;
   int z = x - y;
   int objectcounter = 0;
   for(int i = -number_of_lines_below_above; i <= number_of_lines_below_above; i++)
      {
      round_levels = z + (i * level_of_interest);
      final_price_level = round_levels * Point ;
      objectcounter++;
      string level_name = "Round Number " + DoubleToStr(final_price_level,Digits);
      if(ObjectFind(ChartID(),level_name) != 0)
         {
         if(!ObjectCreate(ChartID(),level_name,OBJ_HLINE,0,Time[1],final_price_level))
            {
            Print("failed to draw object",GetLastError());
            }
         //------Colour-----
         if(!ObjectSet(level_name,OBJPROP_COLOR,clrLightSteelBlue))
            Print(Symbol()," Failed to set colour", GetLastError());
         //------Style-----             
         if(!ObjectSet(level_name,OBJPROP_STYLE,STYLE_DOT))
            Print(Symbol()," Failed to set style", GetLastError());
         //------Show_in_background-----
         if(!ObjectSet(level_name,OBJPROP_BACK,False))
            Print(Symbol()," Failed to set in background", GetLastError()); 
         //------Show_in_5min_chart-----
         if(!ObjectSetInteger(ChartID(),level_name,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M5|OBJ_PERIOD_M15))
            {
            Print("Failed to adjust timeframe: ", GetLastError());
            }  
         }
      }

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
   {   
   for (int i = ObjectsTotal(); i>=0; i--) 
      {
      string name= ObjectName(i);
    
      if (StringSubstr(name,0,5) == "Round") 
         {
         ObjectDelete(name);
         }
      }
   }

